<template lang="pug">
q-field.ui-uploader-image(
	v-model="model"
	:label="label"
	dense
	outlined
	hide-bottom-space
	:rules="localRules"
	stack-label
	ref="fieldRef"
)
	template(#control)
		q-uploader(
			v-bind="$props",
			accept=".jpg, .jpeg, .png",
			hide-upload-btn,
			@added="upload",
			flat,
			:multiple="multiple"
			ref="uploaderRef"
		)
			template(#list="scope")
				.q-gutter-sm.row.items-start
					q-img(
						v-for="(image, index) in model"
						:key="index"
						ratio="1",
						fit="contain"
						:src="image.lowUrl"
					)
						transition(name="fade" mode="out-in")
							.absolute-full.flex.flex-center(v-if="!image.id")
								q-circular-progress(
									:min="0"
									:max="100"
									:value="image.progress"
									size="50px"
									:thickness="0.22"
									color="white"
								)

						.q-img__control(v-if="image.id")
							q-btn(
								size="12px"
								flat
								dense
								round
								color="negative"
								icon="close"
								@click="removeImage(index)"
							)
								ui-tooltip Удалить изображение

					q-btn.self-center(
						v-if="showAddBtn"
						size="50px"
						flat
						color="blue-grey-4"
						round
						icon="add_photo_alternate"
						@click="scope.pickFiles()"
					)

</template>

<script lang="ts">
	import { computed, defineComponent, ref, reactive, onMounted } from 'vue'
	import { client } from '@/plugins/api'
	import uiTooltip from '@/components/ui/UiTooltip.vue'
	import { IVisual } from '@/plugins/utils/types'

	interface IVisualLoading extends IVisual {
		progress?: number
	}

	export default defineComponent({
		name: 'UiUploaderImage',

		components: {
			uiTooltip,
		},

		props: {
			modelValue: {
				type: [Object, Array],
				default: () => [],
			},
			multiple: {
				type: Boolean,
				default: false,
			},
			max: {
				type: Number,
				default: 10,
			},
			label: {
				type: String,
				default: 'Изображения',
			},
			rules: {
				type: Array,
				default: () => [],
			},
		},

		emits: ['update:modelValue'],

		setup(props, { emit }) {
			const uploaderRef = ref(null)
			const fieldRef = ref(null)

			const model = computed({
				get: (): IVisualLoading[] => {
					if (Array.isArray(props.modelValue)) {
						return props.modelValue
					} else {
						return [props.modelValue]
					}
				},
				set: (val) => {
					emit('update:modelValue', props.multiple ? val : val[0])
				},
			})

			const uploadImage = async (file: any) => {
				const uploaderAction = uploaderRef.value as any

				if ((props.multiple && model.value.length > props.max) || (!props.multiple && model.value.length > 0)) {
					uploaderAction.removeFile(file)
					return false
				}

				const src = file.__img.src

				const visual: IVisualLoading = reactive({
					filename: `${new Date().getTime()}-${file.lastModified}-${file.name}`,
					id: undefined,
					lowUrl: src,
					highUrl: src,
					mediumUrl: src,
					originalUrl: src,
					progress: 0,
				})

				model.value = [...model.value, visual]

				try {
					const { id, filename, lowUrl, highUrl, mediumUrl, originalUrl } = await client.visuals.upload(
						file,
						{
							onUploadProgress: ({ loaded, total }: { loaded: number; total: number }) => {
								visual.progress = Math.ceil((100 * loaded) / total)
							},
						},
					)

					visual.id = id
					visual.filename = filename
					visual.lowUrl = lowUrl
					visual.highUrl = highUrl
					visual.mediumUrl = mediumUrl
					visual.originalUrl = originalUrl

					uploaderAction.removeFile(file)
				} catch (e) {
				} finally {
					const fieldAction = fieldRef.value as any
					fieldAction.resetValidation()
				}
			}

			return {
				uploaderRef,
				fieldRef,
				model,
				isFilled: computed(() => !!model.value.length),
				showAddBtn: computed(() => {
					return props.multiple ? props.max > model.value.length : model.value.length === 0
				}),
				localRules: computed(() => {
					return [
						...props.rules,
						(val: IVisualLoading[]) => {
							const isLoading = val.find((item) => !item.id)
							return !isLoading || 'Подождите завершения загрузки'
						},
					]
				}),
				upload(files: File[]) {
					files.forEach((file) => {
						uploadImage(file)
					})
				},

				removeImage(idx: number) {
					model.value = [...model.value.slice(0, idx), ...model.value.slice(idx + 1)]
				},
			}
		},
	})
</script>

<style lang="scss" scoped>
	.q-uploader {
		width: 100%;
		flex-direction: row;
		flex-wrap: wrap;
		max-height: none;
		margin: 0 -8px;
		background: transparent;

		&:deep(.q-uploader__list) {
			width: 100%;
			min-height: 150px;
		}

		&:deep(.q-uploader__header) {
			order: 1;
			width: 150px;
			height: 150px;
			display: none;
		}
	}

	.q-img {
		width: 150px;
		background: #fff;
		border-radius: $generic-border-radius;

		&__control {
			position: absolute;
			background: transparent;
			top: 0;
			right: 0;
			padding: 4px;
			opacity: 0;
			transition: opacity 0.3s ease;
		}

		&:hover {
			.q-img__control {
				opacity: 1;
			}
		}
	}

	.ui-uploader-image {
		&:deep(.q-field__control-container) {
			padding-top: 0 !important;
		}

		&:deep(.q-field__label) {
			transform: translateY(-85%) scale(0.75) !important;
			z-index: 1;
			background: $main-background;
			padding: 0 5px;
			margin-left: -5px;
			right: auto;
			max-width: calc(135% + 10px);
		}
	}
</style>
